## sra-sdk 2.10.7+dfsg

=== test/driver-tool/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/driver-tool

include $(TOP)/build/Makefile.env

runtests: built-in bogus container good vdbcache

TMPDIR ?= /tmp
TEMPDIR ?= $(TMPDIR)

GOOD =\
	fastq-dump \
	fasterq-dump \
	sam-dump \
	sra-pileup \
	vdb-dump \
	prefetch \
	srapath

CONTAINER =\
	SRP000001 \
	SRX000001 \
	SRS000001 \
	SRA000001 \
	ERP000001 \
	DRX000001

good: $(GOOD)

container: $(CONTAINER)

$(TEMPDIR)/tmp.mkfg:
	echo '/LIBS/GUID = "c1d99592-6ab7-41b2-bfd0-8aeba5ef8498"' >$@

mkfg: $(TEMPDIR)/tmp.mkfg

actual:
	@ mkdir actual

built-in:
	@echo "running built-in tests" ; \
	SRATOOLS_TESTING=1 \
	$(BINDIR)/sratools

$(GOOD): | actual mkfg
	@# SRATOOLS_TESTING=2 skip SDL, sub-tool invocation is simulated to always
	@# succeed, but everything up to the exec call is real
	@echo "testing expected output for dry run of" $@ ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(BINDIR):$$PATH \
	SRATOOLS_TESTING=2 \
	SRATOOLS_IMPERSONATE=$@ \
	$(BINDIR)/sratools SRR000001 ERR000001 DRR000001 2>actual/$@.stderr && \
	diff expected/$@.stderr actual/$@.stderr

bogus: | actual mkfg
	@echo "testing expected output for unknown tool" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(BINDIR):$$PATH \
	SRATOOLS_IMPERSONATE=rcexplain \
	$(BINDIR)/sratools 2>actual/$@.stderr ; \
	diff expected/$@.stderr actual/$@.stderr

$(CONTAINER): | actual mkfg
	@echo "testing expected output for container" $@ ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(BINDIR):$$PATH \
	SRATOOLS_IMPERSONATE=fastq-dump \
	$(BINDIR)/sratools $@ 2>actual/$@.stderr ; \
	diff expected/$@.stderr actual/$@.stderr

vdbcache: | actual mkfg
	@echo "testing expected output for run with vdbcache" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(BINDIR):$$PATH \
	SRATOOLS_TESTING=5 \
	SRATOOLS_IMPERSONATE=vdb-dump \
	$(BINDIR)/sratools SRR390728 2>actual/$@.stderr ; \
	diff expected/$@.stderr actual/$@.stderr

.PHONY: runtests bogus container good $(CONTAINER) $(GOOD) vdbcache
.INTERMEDIATE: $(TEMPDIR)/tmp.mkfg

=== debian/changelog ===
sra-sdk (2.10.7+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Trim trailing whitespace.
  * Set field Upstream-Contact in debian/copyright.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Remove obsolete field Contact from debian/upstream/metadata (already present
    in machine-readable debian/copyright).

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 02 Jun 2020 21:47:38 -0400

sra-sdk (2.10.6+dfsg-5) unstable; urgency=medium

  * debian/patches/reenable_legacy_schema_in_sra_load.patch: New patch to
    make use of ncbi-vdb's new SRAUseLegacyDefaultSchema toggle,
    unbreaking tools/sra-load (fastq-load et al.)  (Closes: #961347.)
  * debian/control: Ensure that this toggle is available at build time and
    at runtime.

 -- Aaron M. Ucko <ucko@debian.org>  Mon, 25 May 2020 22:45:07 -0400

=== debian/control ===
Source: sra-sdk
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Charles Plessy <plessy@debian.org>,
           Andreas Tille <tille@debian.org>,
	   Aaron M. Ucko <ucko@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               libngs-sdk-dev (>= 2.9.0),
               libncbi-vdb-dev (>= 2.10.6+dfsg-3~),
               libvdb-sqlite-dev,
               libfuse-dev,
               libhdf5-dev,
               libmagic-dev,
               libxml2-dev,
               python3
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/sra-sdk
Vcs-Git: https://salsa.debian.org/med-team/sra-sdk.git
Homepage: https://github.com/ncbi/sra-tools/
Rules-Requires-Root: no

Package: sra-toolkit
Architecture: amd64
Depends: ${shlibs:Depends},
         libncbi-wvdb2 (>= 2.10.6+dfsg-3~),
         ${misc:Depends}
Recommends: med-config (>= 2.1)
Description: utilities for the NCBI Sequence Read Archive
 Tools for reading the SRA archive, generally by converting individual runs
 into some commonly used format such as fastq.
 .
 The textual dumpers "sra-dump" and "vdb-dump" are provided in this
 release as an aid in visual inspection. It is likely that their
 actual output formatting will be changed in the near future to a
 stricter, more formalized representation[s]. PLEASE DO NOT RELY UPON
 THE OUTPUT FORMAT SEEN IN THIS RELEASE.
 .
 Other tools distributed in this package are:
  abi-dump, abi-load
  align-info
  bam-load
  cache-mgr
  cg-load
  copycat
  fasterq-dump
  fastq-dump, fastq-load
  helicos-load
  illumina-dump, illumina-load
  kar
  kdbmeta
  latf-load
  pacbio-load
  prefetch
  rcexplain
  remote-fuser
  sff-dump, sff-load
  sra-pileup, sra-sort, sra-stat, srapath
  srf-load
  test-sra
  vdb-config, vdb-copy, vdb-decrypt, vdb-encrypt, vdb-get, vdb-lock,
  vdb-passwd, vdb-unlock, vdb-validate
 .
 The "help" information will be improved in near future releases, and
 the tool options will become standardized across the set. More documentation
 will also be provided documentation on the NCBI web site.
 .
 Tool options may change in the next release. Version 1 tool options
 will remain supported wherever possible in order to preserve
 operation of any existing scripts.

=== debian/rules ===
#!/usr/bin/make -f

# Pregenerated with uuidgen -r
DEBIAN_GUID = 806b5c3b-0088-4732-8359-51630950d723

# +pie breaks the build
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

pkg := sra-toolkit

export DEB_CFLAGS_MAINT_APPEND   = -I/usr/include/ncbi-vdb
export DEB_CXXFLAGS_MAINT_APPEND = -I/usr/include/ncbi-vdb
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --no-parallel

OUTDIR=$(CURDIR)/debian/tmp
MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

override_dh_auto_clean:
	-dh_auto_clean

override_dh_clean:
	dh_clean
	rm -f reconfigure build/ld.linux.exe_cmd.sh build/Makefile.config build/Makefile.config.linux.x86_64
	rm -rf test/*/actual test/*/tmp.kfg tools/kqsh/kqsh-sra.[ch]

override_dh_update_autotools_config:
	echo "do nothing"

override_dh_auto_configure:
	# output dir will be checked so create it before
	mkdir -p debian/tmp/usr/lib
	ln -s /usr/lib/$(MULTIARCH) debian/tmp/usr/lib
	#
        # that's no standard configure script lacking support of default options
	#
	# --with-debug sets some options that require header files like compiler.h which
	# is internal to ncbi-vcb and not installed into the package - so this option
	# should not be used.
	./configure --build=$(MULTIARCH) --prefix=$(CURDIR)/debian/tmp/usr --build-prefix=$(CURDIR)/debian/tmp/usr --with-ngs-sdk-prefix=/usr

override_dh_auto_build:
	export LD_LIBRARY_PATH="$$LD_LIBRARY_PATH:$(OUTDIR)/lib"; export OUTDIR=$(OUTDIR) ; make DEB_CFLAGS="$(CFLAGS)" DEB_CXXFLAGS="$(CXXFLAGS)" DEB_LDFLAGS="$(LDFLAGS)"

override_dh_auto_install:
	dh_auto_install -- KONFIG_DIR=$(CURDIR)/debian/sra-toolkit/etc/ncbi

override_dh_install:
	# upstream installs versioned *.a libs - we only want a single version
	ls -l debian/tmp/usr/bin
	cd debian/tmp/usr/bin && \
	for bin in *-orig.* ; do \
	    base=$${bin%-orig.*} && \
	    vbase=$$(readlink "$$(readlink $$base)") && \
	    vdriver=$$(readlink "$$vbase") && \
	    mv -v $$bin $$base-orig && \
	    ln -snfv $${vdriver%%.[0-9]*} $$vbase || exit $$? ; \
	done && \
	for bin in *[a-z] ; do \
	    bin2=$$(readlink $$bin) ; \
	    bin3=$$(readlink "$$bin2") ; \
	    case $$bin2 in \
	        $$bin.* ) rm -v $$bin2 && mv -v $$bin3 $$bin || exit $$? ;; \
	    esac ; \
	done
	dh_install
	# remove susipcious file which is not executable and conflicts with package magic
	rm -f debian/*/usr/bin/magic
	# rename kget which conflicts with kget download manager (see #851219)
	mv debian/$(pkg)/usr/bin/kget debian/$(pkg)/usr/bin/vdb-get
	# Formally supply a standard installation ID to satisfy sratools
	echo '/LIBS/GUID = "$(DEBIAN_GUID)"' >debian/$(pkg)/etc/ncbi/debian.kfg

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test --no-parallel -- -k
endif

override_dh_prep:
	dh_prep -X debian/tmp

## sra-sdk 2.10.9%2Bdfsg

=== Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


#-------------------------------------------------------------------------------
# environment
#
TOP ?= $(CURDIR)
include $(TOP)/build/Makefile.shell


#-------------------------------------------------------------------------------
# default
#
SUBDIRS = \
	shared \
	tools \

# common targets for non-leaf Makefiles; must follow a definition of SUBDIRS
include $(TOP)/build/Makefile.targets

default: $(SUBDIRS)

test: all

$(SUBDIRS) test:
	@ $(MAKE) -C $@

.PHONY: default $(SUBDIRS) test

#-------------------------------------------------------------------------------
# all
#
$(SUBDIRS_ALL):

#-------------------------------------------------------------------------------
# std
#
$(SUBDIRS_STD):

#-------------------------------------------------------------------------------
# install
#
install install-delite:
	@ echo "Checking make status of tools..."
	@ $(MAKE) -s --no-print-directory TOP=$(CURDIR) std
	@ $(MAKE) -s TOP=$(CURDIR) -f build/Makefile.install $@

uninstall:    
	@ $(MAKE) -s TOP=$(CURDIR) -f build/Makefile.install uninstall

.PHONY: install uninstall

#-------------------------------------------------------------------------------
# clean
#
clean: clean_deb clean_rpm clean_test

clean_test:
	@ $(MAKE) -s -C test clean

#-------------------------------------------------------------------------------
# runtests
#
runtests: runtests_test

runtests_test:
	@ $(MAKE) -s -C test runtests

#	@ $(MAKE) -s -C ngs runtests

#-------------------------------------------------------------------------------
# slowtests
#
slowtests: slowtests_test

slowtests_test:
	@ $(MAKE) -s -C test slowtests

#-------------------------------------------------------------------------------
# valgrind
#
valgrind: valgrind_test

valgrind_test:
	@ $(MAKE) -s -C test valgrind

#-------------------------------------------------------------------------------
# RPM
#
ifeq (mac,$(OS))
rpm:
	@ echo "Not making rpm on Mac"
clean_rpm:
else
rpm: std
	@ $(MAKE)       rpm -s TOP=$(CURDIR) -f build/Makefile.rpm
clean_rpm:
	@ $(MAKE) clean_rpm -s TOP=$(CURDIR) -f build/Makefile.rpm
endif

#-------------------------------------------------------------------------------
# DEB
#
ifeq (mac,$(OS))
deb: std
else
deb:
endif
	@ $(MAKE)       deb -s TOP=$(CURDIR) -f build/Makefile.deb
clean_deb:
	@ $(MAKE) clean_deb -s TOP=$(CURDIR) -f build/Makefile.deb

#-------------------------------------------------------------------------------
# pass-through targets
#
COMPILERS = GCC ICC VC++ CLANG
ARCHITECTURES = i386 x86_64 sparc32 sparc64
CONFIG = debug profile release
PUBLISH = scm pubtools
REPORTS = bindir targdir osdir config compilers architecture architectures
PASSTHRUS = \
	out \
	CC $(COMPILERS) \
	$(ARCHITECTURES) \
	$(CONFIG) $(PUBLISH) \
	purify purecov \
	local static dynamic

$(RHOSTS):
	@ $(MAKE) -s TOP=$(CURDIR) -f build/Makefile.env local
	@ $(MAKE) -s TOP=$(CURDIR) -f build/Makefile.env require-proxy-exec
	@ $(MAKE) -s TOP=$(CURDIR) -f build/Makefile.env $@
	@ $(MAKE) -s TOP=$(CURDIR) -f build/Makefile.env rebuild-dirlinks config

$(PASSTHRUS):
	@ $(MAKE) -s TOP=$(CURDIR) -f build/Makefile.env $@
	@ $(MAKE) -s TOP=$(CURDIR) -f build/Makefile.env rebuild-dirlinks config

$(REPORTS):
	@ $(MAKE) -s TOP=$(CURDIR) -f build/Makefile.env $@

.PHONY: $(PASSTHRUS) $(RHOSTS) $(REPORTS)


#-------------------------------------------------------------------------------
# configuration help
#
help configure:
	@ echo "Before initial build, run './configure --build-prefix=<out>' from"
	@ echo "the project root to set the output directory of your builds."
	@ echo
	@ echo "To select a compiler, run 'make <comp>' where"
	@ echo "comp = { "$(COMPILERS)" }."
	@ echo
	@ echo "For hosts that support cross-compilation ( only Macintosh today ),"
	@ echo "you can run 'make <arch>' where arch = { "$(ARCHITECTURES)" }."
	@ echo
	@ echo "To set a build configuration, run 'make <config>' where"
	@ echo "config = { "$(CONFIG)" }."
	@ echo
	@ echo "To select a remote build configuration, run 'make <rhost>' where"
	@ echo "rhost = { "$(RHOSTS)" }."
	@ echo

.PHONY: help configure

=== test/align-cache/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/align-cache

TEST_TOOLS = \

ALL_TOOLS = \
	$(TEST_TOOLS) \

include $(TOP)/build/Makefile.env

DIRTOTEST ?= $(BINDIR)

TOOLTOTEST = $(DIRTOTEST)/align-cache
ifneq ("$(wildcard $(TOOLTOTEST))","")
    BIN_EXISTS = 1
else
    BIN_EXISTS = 0
endif

$(ALL_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

.PHONY: $(TEST_TOOLS)

clean: stdclean

#-------------------------------------------------------------------------------
# align-cache tool tests
#
ifeq (0,$(BIN_EXISTS))
runtests: no-test
else
runtests: align-cache
endif

no-test:
	@ echo $(TOOLTOTEST) does not exist. Test skipped.

align-cache: $(DIRTOTEST)/align-cache
	@ rm -rf CSRA_file.cache
	@ echo "vdb/schema/paths = \"$(VDB_INCDIR)\"" > tmp.kfg
	@ VDB_CONFIG=`pwd` $(DIRTOTEST)/align-cache \
	                          -t 10 --min-cache-count 1 CSRA_file CSRA_file.cache
	@ $(DIRTOTEST)/vdb-validate CSRA_file.cache/ 2>&1 \
	                          | grep --quiet "is consistent"
	@ rm tmp.kfg
	@ rm -rf CSRA_file.cache
	
vg: $(DIRTOTEST)/align-cache
	valgrind --ncbi --suppressions=$(SRCDIR)/valgrind.suppress \
	 $(DIRTOTEST)/align-cache -t 10 --min-cache-count 1 CSRA_file CSRA_file.cache

=== test/install/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/install

ALL_TARGS = \

include $(TOP)/build/Makefile.env

# TOOLS_TO_INSTALL
include $(TOP)/build/Makefile.tools

ROOTDIR = $(SRCDIR)/root

SUBMAKE = $(MAKE) --no-print-directory

ifeq (true,$(LINUX_ROOT))
    #settings for the fake root mode
    INSTALL_DIR = $(ROOTDIR)
    KONFIG_DIR = $(ROOTDIR)/etc/ncbi
    SUBMAKE += LINUX_ROOT=$(LINUX_ROOT) ROOT=$(INSTALL_DIR)
else
    INSTALL_DIR = $(SRCDIR)/install
    KONFIG_DIR = $(INSTALL_DIR)/bin/ncbi
endif

# Override installation location
INST_BINDIR = $(INSTALL_DIR)/bin

SUBMAKE += -C $(TOP) INST_BINDIR=$(INST_BINDIR)

#-------------------------------------------------------------------------------
# runtests
#

INSTALLED_FILES = \
	$(KONFIG_DIR)/certs.kfg                     \
	$(KONFIG_DIR)/default.kfg                   \
	$(KONFIG_DIR)/vdb-copy.kfg                  \
	$(addprefix $(INST_BINDIR)/,$(TOOLS_TO_COPY) \
								$(TOOLS_TO_SYMLINK) \
								sratools$(EXEX) \
								sratools$(VERSION_EXEX) \
								sratools$(MAJVERS_EXEX) \
								)

runtests: test-install

test-install: cleanup
	@ echo "installing to $(INSTALL_DIR)"
	@ #
	@ echo "1. clean install"
	@ #
	@ $(SUBMAKE) install
	@ # not checking $(TOOLS_TO_COPY_OPTIONAL)
	@ for i in $(INSTALLED_FILES); do test -f "$$i" || ( echo "$$i is not found" >>$(INSTALL_DIR)/missing ); done
	@ ! test -f $(INSTALL_DIR)/missing || ! cat $(INSTALL_DIR)/missing
	@ #
	@ # make sure sratools is not Perl
	( ! file $(INST_BINDIR)/sratools$(VERSION_EXEX) | grep Perl ) || ( echo "Error: $(INST_BINDIR)/sratools is a Perl script" && exit 1 )
	@ #
	@ echo "2. uninstall"
	@ #
	@ $(SUBMAKE) uninstall
	@ for i in $(INSTALLED_FILES); do ! test -f "$$i" || ( echo "$$i still exists" >>$(INSTALL_DIR)/exist ); done
	@ ! test -f $(INSTALL_DIR)/exist || ! cat $(INSTALL_DIR)/exist
	@ #
	@ #
	@ echo "3. re-install, preserving modified .kfg files"
	@ #
	@ # install
	@ $(SUBMAKE) install
	@ # modify .kfg files
	@ echo newcert  >$(KONFIG_DIR)/certs.kfg
	@ echo newdflt  >$(KONFIG_DIR)/default.kfg
	@ echo newcopy  >$(KONFIG_DIR)/vdb-copy.kfg
	@ echo newncbi  >$(KONFIG_DIR)/ncbi-vdb.kfg     # this should be renamed and never installed again
	@ # reinstall
	@ $(SUBMAKE) install
	@ # verify changed files have been saved
	@ ( grep newcert  $(KONFIG_DIR)/certs.kfg.orig       >/dev/null ) || ( echo "Error: $(KONFIG_DIR)/certs.kfg.orig has unexpected content" && exit 1 )
	@ ( grep newdflt  $(KONFIG_DIR)/default.kfg.orig     >/dev/null ) || ( echo "Error: $(KONFIG_DIR)/default.kfg.orig has unexpected content" && exit 1 )
	@ ( grep newcopy  $(KONFIG_DIR)/vdb-copy.kfg.orig     >/dev/null ) || ( echo "Error: $(KONFIG_DIR)/vdb-copy.kfg.orig has unexpected content" && exit 1 )
	@ ( grep newncbi  $(KONFIG_DIR)/ncbi-vdb.kfg.orig    >/dev/null ) || ( echo "Error: $(KONFIG_DIR)/ncbi-vdb.kfg.orig has unexpected content" && exit 1 )
	@ ( ! test -f $(KONFIG_DIR)/ncbi-vdb.kfg  ) || ( echo "Error: $(KONFIG_DIR)/ncbi-vdb.kfg exists" && exit 1 )  # gone ...
	@ # verify that further reinstall does not overwrite previously saved files if there is no change
	@ $(SUBMAKE) install
	@ # verify saved files are still there
	@ ( grep newcert  $(KONFIG_DIR)/certs.kfg.orig       >/dev/null ) || ( echo "Error: $(KONFIG_DIR)/certs.kfg.orig has unexpected content after reinstallation" && exit 1 )
	@ ( grep newdflt  $(KONFIG_DIR)/default.kfg.orig     >/dev/null ) || ( echo "Error: $(KONFIG_DIR)/default.kfg.orig has unexpected content after reinstallation" && exit 1 )
	@ ( grep newcopy  $(KONFIG_DIR)/vdb-copy.kfg.orig     >/dev/null ) || ( echo "Error: $(KONFIG_DIR)/vdb-copy.kfg.orig has unexpected content after reinstallation" && exit 1 )
	@ ( grep newncbi  $(KONFIG_DIR)/ncbi-vdb.kfg.orig    >/dev/null ) || ( echo "Error: $(KONFIG_DIR)/ncbi-vdb.kfg.orig has unexpected content after reinstallation" && exit 1 )
	@ ! test -f $(KONFIG_DIR)/ncbi-vdb.kfg          # ... and stays gone
	@ #
	@ #
	@ echo "4. install, discarding older versions of .kfg files"
	@ rm -f $(KONFIG_DIR)/*.orig
	@ $(SUBMAKE) install
	@ # replace .kfg files with older versions
	@ cp $(SRCDIR)/default.kfg.2.8.1 	$(KONFIG_DIR)/default.kfg
	@ cp $(SRCDIR)/certs.kfg.2.8.1 		$(KONFIG_DIR)/certs.kfg
	@ cp $(SRCDIR)/vdb-copy.kfg.2.8.1 	$(KONFIG_DIR)/vdb-copy.kfg
	@ # reinstall
	@ $(SUBMAKE) install
	@ # verify newer files are installed
	@ diff $(BINDIR)/ncbi/default.kfg 			$(KONFIG_DIR)/default.kfg
	@ diff $(BINDIR)/ncbi/certs.kfg 			$(KONFIG_DIR)/certs.kfg
	@ diff $(TOP)/tools/vdb-copy/vdb-copy.kfg 	$(KONFIG_DIR)/vdb-copy.kfg
	@ # verify no old files were saved
	@ ( ! test -f $(KONFIG_DIR)/default.kfg.orig ) 	|| ( echo "Error: $(KONFIG_DIR)/default.kfg.orig exists" && exit 1 )
	@ ( ! test -f $(KONFIG_DIR)/certs.kfg.orig ) 	|| ( echo "Error: $(KONFIG_DIR)/certs.kfg.orig exists" && exit 1 )
	@ ( ! test -f $(KONFIG_DIR)/vdb-copy.kfg.orig ) || ( echo "Error: $(KONFIG_DIR)/vdb-copy.kfg.orig exists" && exit 1 )
	@ #
	@ #
ifeq (,$(LINUX_ROOT))
	#
	# Run the same tests in simulated root mode
	#
	@ $(MAKE) LINUX_ROOT=true
endif

cleanup:
	rm -rf $(INSTALL_DIR)
ifeq (true,$(LINUX_ROOT))
	# in root mode, recreate "system" directories
	mkdir -p $(ROOTDIR)/usr/include  $(ROOTDIR)/etc/profile.d
endif

.PHONY: install

=== test/network-test/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ../..)
MODULE = test/network-test

include $(TOP)/build/Makefile.env

INT_TOOLS = \

EXT_TOOLS = \
	network-test

ALL_TOOLS = \
	$(INT_TOOLS) \
	$(EXT_TOOLS)

#-------------------------------------------------------------------------------
# outer targets
#
all std: vers-includes
	@ $(MAKE_CMD) $(TARGDIR)/$@

$(ALL_TOOLS): vers-includes
	@ $(MAKE_CMD) $(BINDIR)/$@

.PHONY: all std $(ALL_TOOLS)

#-------------------------------------------------------------------------------
# all
#
$(TARGDIR)/all: \
	$(addprefix $(BINDIR)/,$(ALL_TOOLS))

.PHONY: $(TARGDIR)/all

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(BINDIR)/,$(EXT_TOOLS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# vers-includes
#
$(TARGDIR)/vers-includes: $(addsuffix .vers.h,$(EXT_TOOLS))

.PHONY: $(TARGDIR)/vers-includes

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# TOOL_SRC
#
TOOL_SRC = \
	network-testing \
	network-test

TOOL_OBJ = \
	$(addsuffix .$(OBJX),$(TOOL_SRC))

TOOL_LIB = \
	-skapp \
	-sncbi-vdb \
	-lm

$(BINDIR)/network-test: $(TOOL_OBJ)
	$(LD) --exe --vers $(SRCDIR) -o $@ $^ $(TOOL_LIB)

=== test/sra-pileup/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/sra-pileup

TEST_TOOLS = 

include $(TOP)/build/Makefile.env

CONFIGTOUSE ?= NCBI_SETTINGS
DIRTOTEST ?= $(BINDIR)

$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

ifdef PYTHON
runtests: announce check_exit_code check_skiplist

slowtests: announce fastq_dump_vs_sam_dump sam_dump_spotgroup_for_all

else
runtests: ;

slowtests: ;

endif

announce:
	@echo Testing $(DIRTOTEST) CONFIGTOUSE=$(CONFIGTOUSE)

#-------------------------------------------------------------------------------
# scripted tests
#

check_exit_code:
	@ $(CONFIGTOUSE)=/ $(PYTHON) \
	    $(TOP)/build/check-exit-code.py $(DIRTOTEST)/sra-pileup

check_skiplist:
	@ $(CONFIGTOUSE)=/ $(PYTHON) check_skiplist.py $(DIRTOTEST)/sra-pileup

ACC = SRR3332402

#-------------------------------------------------------------------------------
# testing if sam-dump and fastq-dump produce the same READ/QUALITY values
#
fastq_dump_vs_sam_dump :
	@ $(CONFIGTOUSE)=/ $(PYTHON) test_diff_fastq_dump_vs_sam_dump.py \
	    -a $(ACC) -f $(DIRTOTEST)/fastq-dump -m $(DIRTOTEST)/sam-dump

#-------------------------------------------------------------------------------
# testing if sam-dump and fastq-dump produce the same READ/QUALITY values
#
sam_dump_spotgroup_for_all :
	@ $(CONFIGTOUSE)=/ $(PYTHON) test_all_sam_dump_has_spotgroup.py \
	  -a $(ACC) -m $(DIRTOTEST)/sam-dump

.PHONY: $(TEST_TOOLS)

clean: stdclean

=== test/sra-stat/Makefile ===
# ==============================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ==============================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/sra-stat

TEST_TOOLS = \
	testAssemblyStatistics

include $(TOP)/build/Makefile.env

DIRTOTEST ?= $(BINDIR)

$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

.PHONY: $(TEST_TOOLS)

clean: stdclean

#-------------------------------------------------------------------------------

SRC = \
	testAssemblyStatistics

OBJ = \
	$(addsuffix .$(OBJX),$(SRC))

LIB = \
	-skapp \
	-sktst \
	-sncbi-vdb \

$(TEST_BINDIR)/testAssemblyStatistics: $(OBJ)
	$(LP) --exe -o $@ $^ $(LIB)

#-------------------------------------------------------------------------------

runtests: announce test_bases Mismatch

announce:
	@echo Testing $(DIRTOTEST)

slowtests: slow_bases

quick_bases:
	@rm   -rf actual
	@mkdir -p actual

#	@echo
	@echo SRR053325 is a small table
	@NCBI_SETTINGS=/ $(DIRTOTEST)/sra-stat -x SRR053325 > actual/SRR053325
	@diff actual/SRR053325 expected/SRR053325-biological-reloaded

#	@echo
	@echo SRR600096 is a small non-cSRA DB
	@NCBI_SETTINGS=/ $(DIRTOTEST)/sra-stat -x SRR600096 > actual/SRR600096
	@diff actual/SRR600096 expected/SRR600096

#	@echo
	@echo SRR618333 is a small CS_NATIVE table
	@NCBI_SETTINGS=/ $(DIRTOTEST)/sra-stat -x SRR618333 > actual/SRR618333
	@diff actual/SRR618333 expected/SRR618333

#	@echo
	@echo SRR413283 is a small cSRA with local references
	@NCBI_SETTINGS=/ $(DIRTOTEST)/sra-stat -x SRR413283 > actual/SRR413283
	@diff actual/SRR413283 expected/SRR413283-with-AssemblyStatistics

#	@echo
	@echo SRR619505 is a small cSRA with N-s without local references
	@NCBI_SETTINGS=/ $(DIRTOTEST)/sra-stat -x SRR619505 | perl -w strip-path.pl \
	                                                > actual/SRR619505
	@diff actual/SRR619505 expected/SRR619505

#	@echo
	@echo SRR1985136 is a small cSRA with a local reference and 0-length tech-rd
	@NCBI_SETTINGS=/ $(DIRTOTEST)/sra-stat -x SRR1985136 | perl -w strip-path.pl\
                                                    > actual/SRR1985136
	@diff actual/SRR1985136 expected/SRR1985136-with-Changes

#	@echo
	@rm actual/*

R=SRR8483030
test_bases: quick_bases
#	@echo
	@echo ${R} is a run having first 0-lenght bio reads
	@if perl check-run-perm.pl $(DIRTOTEST)/srapath ${R} > /dev/null 2>&1 ; \
	 then                      $(DIRTOTEST)/sra-stat -x ${R} > /dev/null ; fi

#	@echo
	@echo SRR495844 is a cSRA with local references
	@NCBI_SETTINGS=/ $(DIRTOTEST)/sra-stat -x SRR495844 | perl -w strip-path.pl \
                                                    > actual/SRR495844
	@diff actual/SRR495844 expected/SRR495844-with-Changes

#	@echo
	@echo SRR390427 is a non-cSRA DB
	@NCBI_SETTINGS=/ $(DIRTOTEST)/sra-stat -x SRR390427 > actual/SRR390427
	@diff actual/SRR390427 expected/SRR390427

#	@echo
	@echo SRR360929 is a table
	@NCBI_SETTINGS=/ $(DIRTOTEST)/sra-stat -x SRR360929 > actual/SRR360929
	@diff actual/SRR360929 expected/SRR360929-biological

#	@echo
	@rm    actual/*
	@rm -r actual

slow_bases:
	@rm   -vrf actual
	@mkdir -p actual

#	@echo
	@echo SRR586259 is a cSRA without local references
	@NCBI_SETTINGS=/ $(DIRTOTEST)/sra-stat -x SRR586259 | perl -w strip-path.pl \
                                                    > actual/SRR586259
	@diff actual/SRR586259 expected/SRR586259

#	@echo
	@rm    actual/*
	@rmdir actual

all_bases: test_bases slow_bases

Mismatch:
	@mkdir -p actual
	@$(DIRTOTEST)/sra-stat db/SRR6336806.Mismatch >/dev/null 2> actual/Mismatch
	@if grep -q 'Mismatch between calculated and recorded statis' actual/Mismatch;\
	 then echo "Mismatch between calculated and recorded statists was found"; \
		exit 1; fi
	@echo Mismatch OK
	@rm -r actual

slowest_bases:
	NCBI_SETTINGS=/ time $(DIRTOTEST)/sra-stat -xp SRR5362833

#-------------------------------------------------------------------------------

=== tools/prefetch/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ../..)
MODULE = tools/prefetch

INT_TOOLS = \

EXT_TOOLS = \
	prefetch \

ALL_TOOLS = \
	$(INT_TOOLS) \
	$(EXT_TOOLS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/$@-cmn

$(ALL_TOOLS): makedirs
	@ $(MAKE_CMD) $(BINDIR)/$@

.PHONY: all std $(ALL_TOOLS)

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# prefetch
#
PREFETCH_SRC = \
	kfile-no-q \
	PrfMain \
	prefetch \
	PrfRetrier \
	PrfOutFile \

PREFETCH_OBJ = \
	$(addsuffix .$(OBJX),$(PREFETCH_SRC))

PREFETCH_LIB = \
	-lkapp \
	-stk-version \
	-sncbi-vdb \
	-lm


$(BINDIR)/prefetch: $(PREFETCH_OBJ)
	$(LD) --exe --vers $(SRCDIR)/../../shared/toolkit.vers -o $@ $^ $(PREFETCH_LIB)

=== tools/sra-stat/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ../..)
MODULE = tools/sra-stat

INT_TOOLS =

EXT_TOOLS = \
	sra-stat \

ALL_TOOLS = \
	$(INT_TOOLS) \
	$(EXT_TOOLS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/$@-cmn

$(ALL_TOOLS): makedirs
	@ $(MAKE_CMD) $(BINDIR)/$@

.PHONY: all std $(ALL_TOOLS)

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# sra-stat
#  sra statistics
#
SRASTAT_SRC = \
	assembly-statistics \
	sra \
	sra-stat \

SRASTAT_OBJ = \
	$(addsuffix .$(OBJX),$(SRASTAT_SRC))

SRASTAT_LIB = \
	-lkapp \
	-stk-version \
	-sncbi-vdb \
	-sload \
	-lm \

$(BINDIR)/sra-stat: $(SRASTAT_OBJ)
	$(LD) --exe --vers $(SRCDIR)/../../shared/toolkit.vers -o $@ $^ $(SRASTAT_LIB)
